#!perl
# PureMessage OS Health Reports
# ReEntrant Feed pipeline object

package PureMessage::Reports::OS::Pipeline::ReEntrant;

use strict;
use warnings;

use PureMessage::Reports::OS::Pipeline;
use base qw(PureMessage::Reports::OS::Pipeline);

return 1;

# Additional config values:
#  delay - Required - Minimum time between re-entrance
#

# Attributes used internally:
#  row - Incremented each time feed re-enters
#
#  started - Last time software was executed
#

sub start {
    my $self = shift;
    $self->{started} = time();
    $self->SUPER::start(@_);
}

sub check {
    my $self = shift;
    
    if(!$self->{ipc}) {
        if((time() - $self->{started}) + 1 >= $self->{delay})
        {
            if(my $ipc = $self->start) {
                if($ipc->pumpable) {
                    $self->{row}++;
                } else {
                    delete($self->{ipc});
                    warn join(" ", @{$self->{program}}), ": failing!";
                    return;
                }
            } else {
                return;
            }
        } else {
            return 0;
        }
    }
    
    $self->SUPER::check(@_);
}
